VERSION 5.00
Begin VB.UserControl MMZ_X_Pro 
   AutoRedraw      =   -1  'True
   CanGetFocus     =   0   'False
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   FillStyle       =   0  'Solid
   ScaleHeight     =   240
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   320
   ToolboxBitmap   =   "MMZ_X_Pro.ctx":0000
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Label2"
      Height          =   195
      Left            =   1560
      TabIndex        =   1
      Top             =   2400
      Width           =   480
   End
   Begin VB.Label Label1 
      Height          =   495
      Left            =   1800
      TabIndex        =   0
      Top             =   1560
      Width           =   1215
   End
End
Attribute VB_Name = "MMZ_X_Pro"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit

Private Type GRADIENT_RECT
    UpperLeft As Long
    LowerRight As Long
End Type
Private Type TRIVERTEX
    X As Long
    Y As Long
    Red As Integer
    Green As Integer
    Blue As Integer
    Alpha As Integer
End Type
Public Enum YesNoEnum
    No = 0
    Yes = 1
End Enum

Private Declare Function GradientFillRect Lib "msimg32" Alias "GradientFill" (ByVal hDC As Long, pVertex As TRIVERTEX, ByVal dwNumVertex As Long, pMesh As GRADIENT_RECT, ByVal dwNumMesh As Long, ByVal dwMode As Long) As Long

'Default Property Values:
Const m_def_ShowText = False
Const m_def_Color = &HC000&
Const m_def_Value = 0
Const m_def_Min = 0
Const m_def_Max = 100
Const m_def_SliceSize = 6
Const m_def_SliceSpace = 2
Const m_def_BorderSpace = 0
Const m_def_Gradient = 1
'Property Variables:
Dim m_ShowText As Boolean
Dim m_Color As OLE_COLOR
Dim m_Value As Integer
Dim m_Min As Integer
Dim m_Max As Integer
Dim m_SliceSize As Integer
Dim m_SliceSpace As Integer
Dim m_BorderSpace As Byte
Dim m_Gradient As YesNoEnum
Dim m_BackColor As Long
Dim Init As Boolean, Calced As Boolean

Private Sub DecompRGB(ByVal C, R, G, B)
    B = C \ 65536
    G = (C Mod 65536) \ 256
    R = ((C Mod 65536) Mod 256)
End Sub

Private Function Synchronize(Color As Byte) As Integer
    If Color <= 127 Then
        Synchronize = 256 * Color
    Else
        Synchronize = (256 - Color) * -256
    End If
End Function

Private Sub GradientFill(hDC As Long, Color1 As Long, Color2 As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long, Optional Model As Long = 0)
    Dim gRect As GRADIENT_RECT
    Static vert(1) As TRIVERTEX
    Static C1 As Long, C2 As Long
    Dim Red As Byte, Green As Byte, Blue As Byte
    If Color1 <> C1 Then
        DecompRGB Color1, Red, Green, Blue
        vert(0).X = X1
        vert(0).Y = Y1
        vert(0).Red = Synchronize(Red)
        vert(0).Green = Synchronize(Green)
        vert(0).Blue = Synchronize(Blue)
        vert(0).Alpha = 0&
        C1 = Color1
    End If
    If Color2 <> C2 Then
        DecompRGB Color2, Red, Green, Blue
        vert(1).X = X2
        vert(1).Y = Y2
        vert(1).Red = Synchronize(Red)
        vert(1).Green = Synchronize(Green)
        vert(1).Blue = Synchronize(Blue)
        vert(1).Alpha = 0&
        C2 = Color2
    End If
    gRect.UpperLeft = 0
    gRect.LowerRight = 1
    GradientFillRect hDC, vert(0), 2, gRect, 1, Model
End Sub

Private Sub DrawBorder()
    Dim P1, P2, P3, P4, P5 As Long
    UserControl.Cls
    P1 = 10988460
    P2 = 8224383
    P3 = 6842472
    P4 = 12500670
    P5 = 15724527
    UserControl.AutoRedraw = True
    UserControl.BorderStyle = 0
    If Not Init Then
        UserControl.PSet (0, 0), Ambient.BackColor
        UserControl.PSet (0, UserControl.ScaleHeight - 1), Ambient.BackColor
        UserControl.PSet (UserControl.ScaleWidth - 1, 0), Ambient.BackColor
        UserControl.PSet (UserControl.ScaleWidth - 1, UserControl.ScaleHeight - 1), Ambient.BackColor
    End If
    UserControl.PSet (1, 0), P1
    UserControl.PSet (0, 1), P1
    UserControl.PSet (2, 0), P2
    UserControl.PSet (1, 1), P2
    UserControl.PSet (0, 2), P2
    UserControl.PSet (2, 2), P4
    UserControl.Line (3, 0)-(UserControl.ScaleWidth - 3, 0), P3
    UserControl.Line (0, 3)-(0, UserControl.ScaleHeight - 3), P3
    UserControl.Line (2, 1)-(UserControl.ScaleWidth - 2, 1), P4
    UserControl.Line (1, 2)-(1, UserControl.ScaleHeight - 2), P4
    UserControl.Line (3, 2)-(UserControl.ScaleWidth - 3, 2), P5
    UserControl.Line (2, 3)-(2, UserControl.ScaleHeight - 3), P5
    
    UserControl.PSet (1, UserControl.ScaleHeight - 1), P1
    UserControl.PSet (0, UserControl.ScaleHeight - 1 - 1), P1
    UserControl.PSet (2, UserControl.ScaleHeight - 1), P2
    UserControl.PSet (1, UserControl.ScaleHeight - 1 - 1), P2
    UserControl.PSet (0, UserControl.ScaleHeight - 1 - 2), P2
    UserControl.PSet (UserControl.ScaleWidth - 1 - 2, 2), P4
    UserControl.Line (3, UserControl.ScaleHeight - 1)-(UserControl.ScaleWidth - 3, UserControl.ScaleHeight - 1), P3
    UserControl.Line (UserControl.ScaleWidth - 1, 3)-(UserControl.ScaleWidth - 1, UserControl.ScaleHeight - 3), P3
    UserControl.Line (2, UserControl.ScaleHeight - 1 - 1)-(UserControl.ScaleWidth - 2, UserControl.ScaleHeight - 1 - 1), P4
    UserControl.Line (UserControl.ScaleWidth - 1 - 1, 2)-(UserControl.ScaleWidth - 1 - 1, UserControl.ScaleHeight - 2), P4
    UserControl.Line (3, UserControl.ScaleHeight - 1 - 2)-(UserControl.ScaleWidth - 3, UserControl.ScaleHeight - 1 - 2), P5
    UserControl.Line (UserControl.ScaleWidth - 1 - 2, 3)-(UserControl.ScaleWidth - 1 - 2, UserControl.ScaleHeight - 3), P5
    
    UserControl.PSet (UserControl.ScaleWidth - 1 - 1, 0), P1
    UserControl.PSet (UserControl.ScaleWidth - 1, 1), P1
    UserControl.PSet (UserControl.ScaleWidth - 1 - 1, UserControl.ScaleHeight - 1), P1
    UserControl.PSet (UserControl.ScaleWidth - 1, UserControl.ScaleHeight - 1 - 1), P1
    UserControl.PSet (UserControl.ScaleWidth - 1 - 2, UserControl.ScaleHeight - 1), P2
    UserControl.PSet (UserControl.ScaleWidth - 1 - 1, UserControl.ScaleHeight - 1 - 1), P2
    UserControl.PSet (UserControl.ScaleWidth - 1, UserControl.ScaleHeight - 1 - 2), P2
    UserControl.PSet (UserControl.ScaleWidth - 1 - 2, 0), P2
    UserControl.PSet (UserControl.ScaleWidth - 1 - 1, 1), P2
    UserControl.PSet (UserControl.ScaleWidth - 1, 2), P2
    UserControl.PSet (2, UserControl.ScaleHeight - 1 - 2), P4
    UserControl.PSet (UserControl.ScaleWidth - 1 - 2, UserControl.ScaleHeight - 1 - 2), P4
End Sub

Private Sub Progressing(Optional SmallChange As Boolean = False)
    On Error Resume Next
    Static AvailableWidth As Integer, AvailableHeight As Integer
    Static TempMax As Integer
    Dim Text As String
    Static vLeft As Integer, vTop As Integer
    Dim ProgressWidth As Integer, TempValue As Integer
    Dim MainValue As Integer
    If Not SmallChange Then
        Calced = True
        TempMax = Abs(m_Max - m_Min)
        AvailableWidth = Abs(UserControl.ScaleWidth - m_BorderSpace * 2 - 6)
        AvailableHeight = UserControl.ScaleHeight - m_BorderSpace * 2 - 6
        vLeft = m_BorderSpace + 3
        vTop = m_BorderSpace + 3
    End If
    TempValue = Abs(m_Value - m_Min)
    MainValue = TempValue * (100 / TempMax)
    ProgressWidth = MainValue * AvailableWidth / 100
    Label1.Visible = MainValue < 100
    Label1.Move vLeft + ProgressWidth, vTop, AvailableWidth - ProgressWidth, AvailableHeight
    If m_ShowText Then
        Text = MainValue & "%"
        Label2.Caption = Text
    End If
End Sub

Private Sub FullProgress()
    Dim AvailableWidth As Integer, AvailableHeight As Integer
    Dim Color1 As Long, Color2 As Long, Color3 As Long
    Dim TempMax As Integer
    Dim vLeft As Integer, vTop As Integer
    Dim ProgressWidth As Integer, TempValue As Integer
    Dim Count As Integer, Counter As Integer, vMod As Integer
    Dim R As Byte, G As Byte, B As Byte
    Dim X1 As Integer, Y1 As Integer, X2 As Integer, Y2 As Integer
    Dim MainValue As Integer
    TempMax = Abs(m_Max - m_Min)
    If m_Gradient = Yes Then
        Color3 = 240
        DecompRGB m_Color, R, G, B
        If R > G And R > B Then
            Color1 = RGB(250, Color3, Color3)
        ElseIf G > R And G > B Then
            Color1 = RGB(Color3, 250, Color3)
        Else
            Color1 = RGB(Color3, Color3, 250)
        End If
    Else
        Color1 = m_Color
    End If
    Color2 = m_Color
    AvailableWidth = Abs(UserControl.ScaleWidth - m_BorderSpace * 2 - 6)
    AvailableHeight = UserControl.ScaleHeight - m_BorderSpace * 2 - 6
    vLeft = m_BorderSpace + 3
    vTop = m_BorderSpace + 3
    Count = AvailableWidth \ (m_SliceSize + m_SliceSpace)
    vMod = AvailableWidth Mod (m_SliceSize + m_SliceSpace)
    GradientFill UserControl.hDC, m_BackColor, m_BackColor, vLeft, vTop, UserControl.ScaleWidth - vLeft, UserControl.ScaleHeight - vTop
    For Counter = 1 To Count
        X1 = vLeft
        Y1 = vTop
        X2 = X1 + m_SliceSize
        Y2 = vTop + AvailableHeight \ 2
        GradientFill UserControl.hDC, Color1, Color2, X1, Y1, X2, Y2, 1
        X1 = vLeft
        Y1 = Y2
        X2 = X1 + m_SliceSize
        Y2 = vTop + AvailableHeight
        GradientFill UserControl.hDC, Color2, Color1, X1, Y1, X2, Y2, 1
        vLeft = vLeft + m_SliceSize + m_SliceSpace
    Next
    If vMod > m_SliceSize Then vMod = m_SliceSize
    If vMod > 0 Then
        X1 = vLeft
        Y1 = vTop
        X2 = X1 + vMod
        Y2 = vTop + AvailableHeight \ 2
        GradientFill UserControl.hDC, Color1, Color2, X1, Y1, X2, Y2, 1
        X1 = vLeft
        Y1 = Y2
        X2 = X1 + vMod
        Y2 = vTop + AvailableHeight
        GradientFill UserControl.hDC, Color2, Color1, X1, Y1, X2, Y2, 1
    End If
    UserControl.Refresh
End Sub

Private Sub Redraw()
    Label1.BackColor = UserControl.BackColor
    Set Label2.Font = UserControl.Font
    Label2.Move (UserControl.ScaleWidth - Label2.Width) \ 2, (UserControl.ScaleHeight - Label2.Height) \ 2
    DrawBorder
    FullProgress
    Progressing
    Calced = False
End Sub

Private Sub UserControl_AmbientChanged(PropertyName As String)
    UserControl.PSet (0, 0), Ambient.BackColor
    UserControl.PSet (0, UserControl.ScaleHeight - 1), Ambient.BackColor
    UserControl.PSet (UserControl.ScaleWidth - 1, 0), Ambient.BackColor
    UserControl.PSet (UserControl.ScaleWidth - 1, UserControl.ScaleHeight - 1), Ambient.BackColor
End Sub

Private Sub UserControl_Initialize()
    Init = True
    UserControl_InitProperties
    UserControl.BackColor = 16777215
    UserControl.AutoRedraw = True
    UserControl.Size 2655, 375
    Label1.Caption = ""
    Label2.Caption = "0%"
    Label2.BackStyle = 0
    Label2.BackColor = UserControl.BackColor
    Label2.Visible = False
    Init = False
End Sub

Private Sub UserControl_Resize()
    Redraw
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get Color() As OLE_COLOR
    Color = m_Color
End Property

Public Property Let Color(ByVal New_Color As OLE_COLOR)
    m_Color = New_Color
    UserControl.PSet (0, 0), m_Color
    m_Color = UserControl.Point(0, 0)
    Redraw
    PropertyChanged "Color"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,0
Public Property Get Value() As Integer
    Value = m_Value
End Property

Public Property Let Value(ByVal New_Value As Integer)
    'If m_Max >= m_Min Then
    '    If New_Value < m_Min Then New_Value = m_Min
    '    If New_Value > m_Max Then New_Value = m_Max
    'Else
    '    If New_Value < m_Max Then New_Value = m_Max
    '    If New_Value > m_Min Then New_Value = m_Min
    'End If
    m_Value = New_Value
    Progressing Calced
    PropertyChanged "Value"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,0
Public Property Get Min() As Integer
    Min = m_Min
End Property

Public Property Let Min(ByVal New_Min As Integer)
    m_Min = New_Min
    Redraw
    PropertyChanged "Min"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,0
Public Property Get Max() As Integer
    Max = m_Max
End Property

Public Property Let Max(ByVal New_Max As Integer)
    m_Max = New_Max
    Redraw
    PropertyChanged "Max"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=1,0,0,0
Public Property Get SliceSize() As Integer
    SliceSize = m_SliceSize
End Property

Public Property Let SliceSize(ByVal New_SliceSize As Integer)
    m_SliceSize = New_SliceSize
    Redraw
    PropertyChanged "SliceSize"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=1,0,0,0
Public Property Get SliceSpace() As Integer
    SliceSpace = m_SliceSpace
End Property

Public Property Let SliceSpace(ByVal New_SliceSpace As Integer)
    m_SliceSpace = New_SliceSpace
    Redraw
    PropertyChanged "SliceSpace"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=1,0,0,0
Public Property Get BorderSpace() As Byte
    BorderSpace = m_BorderSpace
End Property

Public Property Let BorderSpace(ByVal New_BorderSpace As Byte)
    m_BorderSpace = New_BorderSpace
    Redraw
    PropertyChanged "BorderSpace"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=1,0,0,0
Public Property Get Gradient() As YesNoEnum
    Gradient = m_Gradient
End Property

Public Property Let Gradient(ByVal New_Gradient As YesNoEnum)
    m_Gradient = New_Gradient
    Redraw
    PropertyChanged "Gradient"
End Property

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_Color = m_def_Color
    m_BackColor = 16777215
    m_Value = m_def_Value
    m_Min = m_def_Min
    m_Max = m_def_Max
    m_SliceSize = m_def_SliceSize
    m_SliceSpace = m_def_SliceSpace
    m_BorderSpace = m_def_BorderSpace
    m_Gradient = m_def_Gradient
    m_ShowText = m_def_ShowText
    Label2.Visible = m_ShowText
    Redraw
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    m_Color = PropBag.ReadProperty("Color", m_def_Color)
    m_Value = PropBag.ReadProperty("Value", m_def_Value)
    m_Min = PropBag.ReadProperty("Min", m_def_Min)
    m_Max = PropBag.ReadProperty("Max", m_def_Max)
    m_SliceSize = PropBag.ReadProperty("SliceSize", m_def_SliceSize)
    m_SliceSpace = PropBag.ReadProperty("SliceSpace", m_def_SliceSpace)
    m_BorderSpace = PropBag.ReadProperty("BorderSpace", m_def_BorderSpace)
    m_Gradient = PropBag.ReadProperty("Gradient", m_def_Gradient)
    m_ShowText = PropBag.ReadProperty("ShowText", m_def_ShowText)
    Set UserControl.Font = PropBag.ReadProperty("Font", Ambient.Font)
    UserControl.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    UserControl.ForeColor = PropBag.ReadProperty("ForeColor", &H80000012)
    m_BackColor = UserControl.Point(0, 0)
    Label2.Visible = m_ShowText
    Redraw
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("Color", m_Color, m_def_Color)
    Call PropBag.WriteProperty("Value", m_Value, m_def_Value)
    Call PropBag.WriteProperty("Min", m_Min, m_def_Min)
    Call PropBag.WriteProperty("Max", m_Max, m_def_Max)
    Call PropBag.WriteProperty("SliceSize", m_SliceSize, m_def_SliceSize)
    Call PropBag.WriteProperty("SliceSpace", m_SliceSpace, m_def_SliceSpace)
    Call PropBag.WriteProperty("BorderSpace", m_BorderSpace, m_def_BorderSpace)
    Call PropBag.WriteProperty("Gradient", m_Gradient, m_def_Gradient)
    Call PropBag.WriteProperty("ShowText", m_ShowText, m_def_ShowText)
    Call PropBag.WriteProperty("Font", UserControl.Font, Ambient.Font)
    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H8000000F)
    Call PropBag.WriteProperty("ForeColor", UserControl.ForeColor, &H80000012)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,false
Public Property Get ShowText() As Boolean
    ShowText = m_ShowText
End Property

Public Property Let ShowText(ByVal New_ShowText As Boolean)
    m_ShowText = New_ShowText
    Label2.Visible = m_ShowText
    PropertyChanged "ShowText"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Font
Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
    Set Font = UserControl.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set UserControl.Font = New_Font
    Redraw
    PropertyChanged "Font"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
    BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    UserControl.BackColor() = New_BackColor
    m_BackColor = UserControl.Point(0, 0)
    Redraw
    PropertyChanged "BackColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,ForeColor
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
    ForeColor = UserControl.ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    UserControl.ForeColor() = New_ForeColor
    Redraw
    PropertyChanged "ForeColor"
End Property
